﻿using System;
using System.Collections.Generic;

namespace Common.JsonUtil
{
    internal class SafeDictionary<TKey, TValue>
    {
        private readonly object _Padlock = new object();
        private readonly Dictionary<TKey, TValue> _Dictionary = new Dictionary<TKey, TValue>();


        public bool TryGetValue(TKey key, out TValue value)
        {
            bool val = false;
            value = default(TValue);
            foreach (TKey k in _Dictionary.Keys)
            {
                if (key.ToString().Equals(k.ToString(), StringComparison.InvariantCultureIgnoreCase))
                {
                    value =  _Dictionary[k];
                    val = true;
                }
            }
            return val;
        }

        public TValue this[TKey key]
        {
            get
            {
                return _Dictionary[key];
            }
        }
        public IEnumerator<KeyValuePair<TKey, TValue>> GetEnumerator()
        {
            return ((ICollection<KeyValuePair<TKey, TValue>>)_Dictionary).GetEnumerator();
        }

        public void Add(TKey key, TValue value)
        {
            lock (_Padlock)
            {
                if (_Dictionary.ContainsKey(key) == false)
                    _Dictionary.Add(key, value);
            }
        }
    }
}
