﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Specialized;
using Common.Extensions;

namespace OAuth
{
    public class QQ
    {
        private static IOAuthConfig config = new QQOAuthConfig();

        public QQ()
        {
 
        }

        public string GetAuthCodeUrl(string callback,out string salt)
        {
            string api = "/oauth2.0/authorize";

            salt = Common.RandomText.String(16);

            string url = string.Format("{0}{1}?client_id={2}&response_type=code&redirect_uri={3}{4}&state={5}",
                config.BaseUrl, api, config.AppKey, config.Domain, callback, salt);

            return url;
        }

        public string GetAccessToken(string code, string callback)
        {
            string api = "/oauth2.0/token";

            string salt = Common.RandomText.String(16);

            string queryString = string.Format("grant_type=authorization_code&code={0}&client_id={1}&client_secret={2}&redirect_uri={3}&state={4}",
                code, config.AppKey, config.AppSecret, config.Domain, salt);

            string apiurl = config.BaseUrl + api;

            string result = OAuthCommon.HttpPost(apiurl, queryString);

            NameValueCollection nvc = Common.Web.QueryString.GetQueryList(result);

            return nvc["access_token"];

        }

        public string GetUID(string access_token)
        {
            string api = "/oauth2.0/me";

            string url = string.Format("{0}{1}?access_token={2}",
                config.BaseUrl, api, access_token);

            string result = OAuthCommon.HttpGet(url);

            return Common.JsonUtil.Json2.Instance.ToObject<QQShortUser>(result.ExTrimPrefix("callback(").ExTrimSuffix(");").Trim()).Openid;
        }

        public QQUser GetUserInfo(string access_token, string openid)
        {
            string api = "/user/get_user_info";

            string url = string.Format("{0}{1}?access_token={2}&oauth_consumer_key={3}&openid={4}&format=json ",
                config.BaseUrl, api, access_token, config.AppKey, openid);

            string result = OAuthCommon.HttpGet(url);

            return Common.JsonUtil.Json2.Instance.ToObject<QQUser>(result);
        }
    }
}
