﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Common.Extensions;

namespace OAuth
{
    public class Sina
    {
        private static IOAuthConfig config = new SinaOAuthConfig();

        public Sina()
        {
            
        }

        public string GetAuthCodeUrl(string callback,out string salt)
        {
            string api = "/oauth2/authorize";

            salt = Common.RandomText.String(16);          

            string url = string.Format("{0}{1}?client_id={2}&response_type=code&redirect_uri={3}{4}&state={5}",
                config.BaseUrl, api, config.AppKey, config.Domain, callback, salt);

            return url;
        }

        public SinaAccessToken GetAccessToken(string code, string callback)
        {
            string api = "/oauth2/access_token";
            
            string queryString = string.Format("grant_type=authorization_code&code={0}&client_id={1}&client_secret={2}&redirect_uri={3}{4}", 
                code, config.AppKey, config.AppSecret, config.Domain, callback);

            string apiurl = config.BaseUrl + api;

            string result = OAuthCommon.HttpPost(apiurl, queryString);

            return Common.JsonUtil.Json2.Instance.ToObject<SinaAccessToken>(result);
        }

        public long GetUID(string access_token)
        {
            string api = "/2/account/get_uid.json";

            string url = string.Format("{0}{1}?access_token={2}",
                config.BaseUrl, api, access_token);

            string result = OAuthCommon.HttpGet(url);

            return Common.JsonUtil.Json2.Instance.ToObject<ShortSinaUser>(result).UID;
        }

        public SinaUser GetUserInfo(string access_token,long uid)
        {
            string api = "/2/users/show.json";

            string url = string.Format("{0}{1}?access_token={2}&uid={3}",
                config.BaseUrl, api,  access_token, uid);

            string result = OAuthCommon.HttpGet(url);

            return Common.JsonUtil.Json2.Instance.ToObject<SinaUser>(result);
        }

        
    }
}
