﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using Discuz.Data;
using System.Data.SqlClient;

namespace Web.DNT
{
    public class QQDataAccess
    {
        public static int DbInstall()
        {
            string sql = @"CREATE TABLE [dbo].[dnt_QQOAuth](
	                                [uid] [int] NOT NULL,
	                                [openid] [varchar](100) COLLATE Chinese_PRC_CS_AS_KS_WS NOT NULL,
                                    CONSTRAINT [PK_dnt_QQOAuth_qzlogin_qqopenid] PRIMARY KEY CLUSTERED 
                                (
	                                [openid] ASC
                                )WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
                                ) ON [PRIMARY]";

            return DbHelper.ExecuteNonQuery(CommandType.Text, sql);
        }

        public static int CreateUser(int uid, string openid)
        {
            string sql = "INSERT INTO [dnt_QQOAuth] ([uid] ,[openid]) VALUES (@uid ,@openid)";
            SqlParameter[] parameters = { 
                                        new SqlParameter("@uid", uid),
                                        new SqlParameter("@openid", openid)
                                        };
            return DbHelper.ExecuteNonQuery(CommandType.Text, sql, parameters);
        }

        public static int GetUID(string openid)
        {
            int uid=-1;

            string sql = string.Format("SELECT [uid] FROM [dnt_QQOAuth] WHERE [openid]=@openid");
            SqlParameter param = new SqlParameter("@openid", openid);
            var val =  DbHelper.ExecuteScalar(CommandType.Text, sql, param);
            if (null != val && DBNull.Value != val)
            {
                int.TryParse(val.ToString(), out uid);
            }

            return uid;
        }

        public static string GetOpenID(string uid)
        {
            string openid = string.Empty;

            string sql = string.Format("SELECT [openid] FROM [dnt_QQOAuth] WHERE [uid]=@uid");
            SqlParameter param = new SqlParameter("@uid", uid);
            var val = DbHelper.ExecuteScalar(CommandType.Text, sql, param);

            if (null != val && DBNull.Value != val)
            {
                openid = val.ToString();
            }

            return openid;
        }

        public static int DeleteUser(int uid)
        {
            string sql = "DELETE FROM [dnt_QQOAuth] WHERE [uid]=@uid";
            SqlParameter param = new SqlParameter("@uid", uid);
            return DbHelper.ExecuteNonQuery(CommandType.Text, sql, param);
        }
    }
}